//*******************************************************************************************************/
//* FileName        : clUsb.h
//*
//* Description	    : USB driver for MFC
//*
//* Contents:		: axis		y (x) axis info.	##
//*					  timeaxis	time axis info
//*					  clUsb		The plot itself.
//*
//* Author          : Jan Vidar Berger
//*******************************************************************************************************/
#if !defined(AFX_DQPLOT_H__0D536D37_5CF1_11D1_AED1_0060973A08A4__INCLUDED_)
#define AFX_DQPLOT_H__0D536D37_5CF1_11D1_AED1_0060973A08A4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// clUsb.h : header file
//
//#define MAXLEGENDS	10	##
//#define MAXSERIES	50

//*******************************************************************************************************/





/*******************************************************************************************************/
//* Class           : clUsb
//*
//* Base Class      : public CWnd
//*
//* Description     : Plot Component.
//*
//*					  This is a standard plot and can be used for any application.
//*
//*						1. A special 'autoscroll'mode exist for real time plots.
//*						2. Only a minimum of features are implemented.
//*						3. Series and legends are separated and must be set up individually.
//*						4. A set of defines (see top of file) are used to set the max array sizes.
//*						5. Only time are supported as x-axis.
//*						6. A large range of pre-calculated values are used for maximum speed.
//*
//* Author          : Jan Vidar Berger
//*******************************************************************************************************/

class AFX_EXT_CLASS clUsb : public CWnd
{
// Construction
public:
	clUsb();
	virtual ~clUsb();

// Attributes
public:
//	int			m_iMleft;			// left margin

// Operations
public:
//	BOOL		Create(DWORD dwstyle, CRect &rect, CWnd *pParent, UINT id);	clUsb::FindTheHID

//	virtual	bool		FindTheHID(void);	//##
		bool		FindTheHID(void);
	virtual	void		GetDeviceCapabilities();

//	virtual BOOL AddPoint(int serie, CTime &valuetime, double &y);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(clUsb)
	//}}AFX_VIRTUAL

// Implementation
public:


	// Generated message map functions
protected:
	//{{AFX_MSG(clUsb)
//	afx_msg void OnPaint();
	//}}AFX_MSG
//	BOOL clUsb::OnEraseBkgnd(CDC* pDC) ;

//	DECLARE_MESSAGE_MAP()

};






/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DQPLOT_H__0D536D37_5CF1_11D1_AED1_0060973A08A4__INCLUDED_)
